void interrupt irq_music();
#define INLINE
#define RAWFILE
unsigned short sqWavePeriod1; // square wave period (us) #1
unsigned short sqWaveUs1 = 0; // number of us since last falling edge
unsigned short sqWavePeriod2;
unsigned short sqWaveUs2 = 0;
unsigned short sqWavePeriod3;
unsigned short sqWaveUs3 = 0;
unsigned char sqWaveEnable; // bit 0: sqWave1 bit 1: sqWave2 bit 2: sqWave3
unsigned short sfxSqWavePeriod;
FILE* musicFile;
FILE* sfxFile;
unsigned char sqWaveLeft1;
unsigned char sqWaveLeft2;
unsigned char sqWaveLeft3;
unsigned char timeCounter;
unsigned char needsUpdating;
int flipwaves = 1;
void init_music(char* filename);
void stop_music();
void update_music();
void play_soundfx(char *filename);
void init_music(char* filename) { // CALL THIS ONCE FOR EACH NEW SONG
        if (strcmp(filename, "BADSONG1") == 0) {
                flipwaves = 0;
        }
        if (strcmp(filename, "THUNDER") == 0) {
                //flipwaves = 0;
        }

        sqWaveUs1 = 0;
        sqWaveUs2 = 0;
        sqWaveUs3 = 0;
        sqWaveEnable = 0;
        sqWaveLeft1 = 0;
        sqWaveLeft2 = 0;
        sqWaveLeft3 = 0;
        musicFile = fopen(filename, "r");
        sfxFile = NULL;
        outportb(0x43, 0x36);
        outportb(0x40, 0x40);
        outportb(0x40, 0x25);
        outportb(0x61, inportb(0x61) | 3); // enable beeper
        setvect(8, irq_music);
}
void play_soundfx(char *filename) {
        if (sfxFile != NULL) {
                fclose(sfxFile);
        }
        sfxFile = fopen(filename, "r");
}
void stop_music() { // CALL THIS TO STOP MUSIC, **MUSIC MUST BE PLAYING CURRENTLY**
        sqWaveEnable = 0;
        fclose(musicFile);
        outportb(0x61, inportb(0x61) & 0xfc); // disable beeper
        flipwaves = 1;
}

int frameCount = 0;
#ifdef RAWFILE
void update_music() {
        char buffer[19];
        fgets(buffer, 19, musicFile);
        if (feof(musicFile)) {
                fseek(musicFile, 0, SEEK_SET);
                fgets(buffer, 19, musicFile);
        }
        //printf("Fr%05d %s", ++frameCount, buffer);
        if (flipwaves) {
                sqWavePeriod2 = atoi(buffer);
                sqWavePeriod1 = atoi(buffer + 6);
        }
        else {
                sqWavePeriod1 = atoi(buffer);
                sqWavePeriod2 = atoi(buffer + 6);
        }
        sqWavePeriod3 = atoi(buffer + 12);
        sqWaveEnable = (sqWavePeriod1 != 0) | ((sqWavePeriod2 != 0) << 1) | ((sqWavePeriod3 != 0) << 2);
        if (sfxFile != NULL) {
                fgets(buffer, 7, sfxFile);
                if (feof(sfxFile)) {
                        fclose(sfxFile);
                        sfxFile = NULL;
                } else {
                        if (flipwaves) {
                                sqWavePeriod2 = atoi(buffer);
                        } else {
                                sqWavePeriod1 = atoi(buffer);
                        }
                }
        }
}
#else
void update_music() { // CALL THIS EVERY FRAME TO OPTIONALLY READ NEW LINES
        char notes[] = { 0, 2, 3, 5, 7, 8, 10 };
        char buffer[26];
        char noteIdx;
        if (!(sqWaveLeft1 && sqWaveLeft2 && sqWaveLeft3)) { // only read new lines when necessary
                fgets(buffer, 26, musicFile);
                if (feof(musicFile)) {
                        fseek(musicFile, 0, SEEK_SET);
                        fgets(buffer, 26, musicFile);
                }
                printf("Fr%05d %s", ++frameCount, buffer);
                if (!sqWaveLeft1) {
                        if (buffer[0] == ' ') {
                                sqWaveEnable &= ~1; // disable wave 1
                        }
                        else {
                                noteIdx = notes[buffer[0] - 'A'];
                                noteIdx |= (buffer[2] - '0') << 4;
                                if ((noteIdx & 0x0f) < 3) {
                                        noteIdx += 0x10;
                                }
                                if (buffer[1] == '#') {
                                        noteIdx++;
                                }
                                else if (buffer[1] == 'b') {
                                        noteIdx--;
                                }
                                sqWaveUs1 = 0;
                                sqWavePeriod1 = periods[noteIdx];
                                sqWaveEnable |= 1; // enable wave 1
                        }
                        if (buffer[4] != ' ') {
                                sqWaveLeft1 = atoi(buffer + 4);
                        }
                }
                if (!sqWaveLeft2) {
                        if (buffer[8] == ' ') {
                                sqWaveEnable &= ~2; // disable wave 2
                        }
                        else {
                                noteIdx = notes[buffer[8] - 'A'];
                                noteIdx |= (buffer[10] - '0') << 4;
                                if ((noteIdx & 0x0f) < 3) {
                                        noteIdx += 0x10;
                                }
                                if (buffer[9] == '#') {
                                        noteIdx++;
                                }
                                else if (buffer[9] == 'b') {
                                        noteIdx--;
                                }
                                sqWaveUs2 = 0;
                                sqWavePeriod2 = periods[noteIdx];
                                sqWaveEnable |= 2; // enable wave 2
                        }
                        if (buffer[12] != ' ') {
                                sqWaveLeft2 = atoi(buffer + 12);
                        }
                }
                if (!sqWaveLeft3) {
                        if (buffer[16] == ' ') {
                                sqWaveEnable &= ~4; // disable wave 3
                        }
                        else {
                                noteIdx = notes[buffer[16] - 'A'];
                                noteIdx |= (buffer[18] - '0') << 4;
                                if ((noteIdx & 0x0f) < 3) {
                                        noteIdx += 0x10;
                                }
                                if (buffer[17] == '#') {
                                        noteIdx++;
                                }
                                else if (buffer[17] == 'b') {
                                        noteIdx--;
                                }
                                sqWaveUs3 = 0;
                                sqWavePeriod3 = periods[noteIdx];
                                sqWaveEnable |= 4; // enable wave 3
                        }
                        if (buffer[20] != ' ') {
                                sqWaveLeft3 = atoi(buffer + 20);
                        }
                }
                //printf("Just updated freqs, periods: %d %d %d, enable: %d\n", sqWavePeriod1, sqWavePeriod2, sqWavePeriod3, sqWaveEnable);
        }
        else {
                printf("       |       |       |\n");
        }
        if (sqWaveLeft1) sqWaveLeft1--;
        if (sqWaveLeft2) sqWaveLeft2--;
        if (sqWaveLeft3) sqWaveLeft3--;
}
#endif
unsigned int irqsElapsed;

void interrupt irq_music() {
        unsigned short time;
        unsigned char select;
        if (timeCounter == 66) {
                timeCounter = 0;
        }
        else {
                timeCounter = 66;
        }
        select = (irqsElapsed >> 1) & 3;
        if (select == 2) select = 1;
        if (select == 3) select = 2;
        if ((sqWaveEnable & 3) == 0 && (select != 2)) {
                time = 1;
        }
        else if (sqWaveEnable & 7) {
                while ((sqWaveEnable & (1 << select)) == 0) {
                        select++;
                        if (select > 2) select = 0;
                }
                if (select == 0) {
                        time = (sqWaveEnable & 1) ? sqWavePeriod1 : 1;
                }
                else if (select == 1) {
                        time = (sqWaveEnable & 2) ? sqWavePeriod2 : 1;
                }
                else {
                        time = (sqWaveEnable & 4) ? sqWavePeriod3 : 1;
                }
        }
        else {
                time = 1;
        }
        time >>= 1;
        irqsElapsed++;
        outportb(0x43, 0xb6);
        outportb(0x42, (time & 0xff));
        outportb(0x42, (time >> 8));
        outportb(0x20, 0x20);
}